GET /{index}/_segments

All methods and paths for this operation:

GET /_segments

GET /{index}/_segments

Get low-level information about the Lucene segments in index shards. For data streams, the API returns information about the stream's backing indices.

Required authorization

  • Index privileges: monitor

Path parameters

  • index string | array[string] Required

    Comma-separated list of data streams, indices, and aliases used to limit the request. Supports wildcards (*). To target all data streams and indices, omit this parameter or use * or _all.

Query parameters

  • allow_no_indices boolean

    A setting that does two separate checks on the index expression. If false, the request returns an error (1) if any wildcard expression (including _all and *) resolves to zero matching indices or (2) if the complete set of resolved indices, aliases or data streams is empty after all expressions are evaluated. If true, index expressions that resolve to no indices are allowed and the request returns an empty result.

  • expand_wildcards string | array[string]

    Type of index that wildcard patterns can match. If the request can target data streams, this argument determines whether wildcard expressions match hidden data streams. Supports comma-separated values, such as open,hidden.

    Supported values include:

    • all: Match any data stream or index, including hidden ones.
    • open: Match open, non-hidden indices. Also matches any non-hidden data stream.
    • closed: Match closed, non-hidden indices. Also matches any non-hidden data stream. Data streams cannot be closed.
    • hidden: Match hidden data streams and hidden indices. Must be combined with open, closed, or both.
    • none: Wildcard expressions are not accepted.

    Values are all, open, closed, hidden, or none.

  • ignore_unavailable boolean

    If false, the request returns an error if it targets a concrete (non-wildcarded) index, alias, or data stream that is missing, closed, or otherwise unavailable. If true, unavailable concrete targets are silently ignored.

Responses

  • 200 application/json
    Hide response attributes Show response attributes object
    • indices object Required
      Hide indices attribute Show indices attribute object
      • * object Additional properties
        Hide * attribute Show * attribute object
        • shards object Required
    • _shards object Required
      Hide _shards attributes Show _shards attributes object
      • failed number

        The number of shards the operation or search attempted to run on but failed.

      • successful number

        The number of shards the operation or search succeeded on.

      • total number

        The number of shards the operation or search will run on overall.

      • failures array[object]
        Hide failures attributes Show failures attributes object
        • index
        • node string
        • reason
        • shard number
        • status string
        • primary boolean
      • skipped number
GET /{index}/_segments
GET /my-index-000001/_segments
resp = client.indices.segments(
    index="my-index-000001",
)
const response = await client.indices.segments({
  index: "my-index-000001",
});
response = client.indices.segments(
  index: "my-index-000001"
)
$resp = $client->indices()->segments([
    "index" => "my-index-000001",
]);
curl -X GET -H "Authorization: ApiKey $ELASTIC_API_KEY" "$ELASTICSEARCH_URL/my-index-000001/_segments"
client.indices().segments(s -> s
    .index("my-index-000001")
);
Response examples (200)
A response describing information about index segments.
{
  "_shards": {
    "total": 2,
    "successful": 2,
    "failed": 0
  },
  "indices": {
    "kibana_sample_data_ecommerce": {
      "shards": {
        "0": [
          {
            "routing": {
              "state": "STARTED",
              "primary": false,
              "node": "zZg9NuPhQPKO3LMRkMo2iw"
            },
            "num_committed_segments": 4,
            "num_search_segments": 4,
            "segments": {
              "_0": {
                "generation": 0,
                "num_docs": 500,
                "deleted_docs": 0,
                "size_in_bytes": 524718,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_1": {
                "generation": 1,
                "num_docs": 500,
                "deleted_docs": 0,
                "size_in_bytes": 526100,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_2": {
                "generation": 2,
                "num_docs": 2000,
                "deleted_docs": 0,
                "size_in_bytes": 1846181,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_3": {
                "generation": 3,
                "num_docs": 1675,
                "deleted_docs": 0,
                "size_in_bytes": 1572960,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              }
            }
          },
          {
            "routing": {
              "state": "STARTED",
              "primary": true,
              "node": "sp27SQiNTQWKpBKoRcnfQQ"
            },
            "num_committed_segments": 5,
            "num_search_segments": 5,
            "segments": {
              "_0": {
                "generation": 0,
                "num_docs": 187,
                "deleted_docs": 0,
                "size_in_bytes": 227245,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_1": {
                "generation": 1,
                "num_docs": 253,
                "deleted_docs": 0,
                "size_in_bytes": 297549,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_2": {
                "generation": 2,
                "num_docs": 560,
                "deleted_docs": 0,
                "size_in_bytes": 580918,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_3": {
                "generation": 3,
                "num_docs": 1603,
                "deleted_docs": 0,
                "size_in_bytes": 1506385,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              },
              "_4": {
                "generation": 4,
                "num_docs": 2072,
                "deleted_docs": 0,
                "size_in_bytes": 1913051,
                "committed": true,
                "search": true,
                "version": "10.3.1",
                "compound": true,
                "attributes": {
                  "Lucene90StoredFieldsFormat.mode": "BEST_SPEED"
                }
              }
            }
          }
        ]
      }
    }
  }
}